-- ****************************************************************************************************** --
-- Tickisms, By Richard
--
-- Constants:

local VERSION = "1.26";

-- Varibles needed by Addon
local petsummoned = 0;
local issummoned = 0;
local cID = 0;
local CName = 0;
local CSpellID = 0;
local icon = 0;
local mounted = 0;
local status = true; -- If false will not display quotes
local oldHeadLink = nil; -- if nil, not currently cooking, and/or didn't equip chef's hat 
local oldWeaponLink = nil; -- if nil, not currently cooking, and/or didn't equip Rolling Ping 
local oldShowHead = nil;
local oldTitle = nil;
local channel = "SAY";


-- Sayings for when you login to world
local Tickisms_Login_Array = {
	"I hate broccoli, and yet, in a certain sense, I am broccoli.",
	"Heh, heh. Those darn ninjas. They're wacky.",
	"Can't lose my name, it's on all my stationery!",
	"I feel just like Uncle Wiggly!",
	"Roof pig! Most unexpected.",
	"Mustache, I will NOT be mocked by you!",
	"Sanity, you're a madman!",
	"Why am I here? Why does my mind have wings? Why do blue midgets hit me with fish?!",
	"Sun worshipping dog launchers you face the Tick! and his dog Speak!",
	"Arthur, the fourth dimension is just one big crazy do not enter clambake of wierdity! and how does it work? Never you mind!",
	"I'm startin' to like the cut of this man's jibberish",
	"It started as a great day. No, a super day, perfect in every way; well, nigh-perfect really.",
	"I'm betting I'm just abnormal enough to survive!",
	"So this is what kingdom come is like.",
	"Evil is just plain bad!",
	"Evildoers! Eat my justice!",
	"Wait a minute ... I've heard about people like you ... are you saying; you don't believe in Santa Claus?!!!",
	"Odds are it wasn't the real Santa, but how can you ever be sure? Here's a clue; if he jumps and kicks you in the stomach, it's probably not Santa!",
	"It's starting to smell a little like danger in here.",
	"My mind is a scary place!",
	"I don't know the meaning of the word surrender! I mean, I know it, I'm not dumb...just not in this context ..."
 };

-- Sayings for when you summon your mount
local Tickisms_mount_Array = {
        "The boots of evil were made for walkin'",
        "Arthur! Carmalita! Look Out! Runaway Whale!",
        "When evil sees a twin headed Arthur powered flying engine of justice barreling down upon it, great will be its trembling!",
        "He's probably out joyriding in my sleek chassis!",
        "Step on it, chum and don't spare the mucus!" };

-- Sayings for when you open cooking profession
local Tickisms_cooking_Array = {
	"Yeast Devil! Back to the oven that baked you!",
	"Not baked goods, professor Baked Bads!",
	"Ah 50 seconds to defuse a loaf of bread not good!",
	"Breadmaster! Your culinary crimewave has crashed against the shores of justice!",
	"Chef of chicanery your buns are mine!",
	"Quit yanking my food chain!"};

-- Possible new sayings for future release
-- Secret crime viewfinder engaged. (Goggle Text)
-- We are not two men ... we are TEN men! (Zone into 10 MAN)
-- Villains, I say to you now, Knock off all that Evil!  (possible boss kill)
-- Need saying for rezing

-- command for slash
SLASH_TICKISMS1 = '/tickisms';

local TickismsFrame = CreateFrame("FRAME");
TickismsFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
TickismsFrame:SetScript("OnEvent", function(self, event, ...)
return self[event](...) end);

-- ****************************************************************************************************** --
-- Function:  Turns off and on messages and displays usage
--
function SlashCmdList.TICKISMS(msg, editbox)
-- Any leading non-whitespaces is captured into command; the rest is capurted into rest
  local command, rest, temp, oldchannel;

  msg=msg:upper();
  command, rest = msg:match("^(%S*)%s*(.-)$");

  if command == "QUOTE" or command == "CHANNEL" then
    oldchannel = channel;
    temp, rest = rest:match("^(%S*)%s*(.-)$");
    if temp == "GUILD" or temp == "PARTY" or temp == "SAY" then
      channel = temp;
    end
  end

  if command == "OFF" and rest == "" then
    print ("tickisms is disabled");
    status = false;
  elseif command == "ON" and rest == "" then
    print ("tickisms is enabled");
    status = true;
  elseif command == "STATUS" and rest == "" then
    if status then 
      print ("Tickisms status: enabled - Version: " .. VERSION .. " - Default Channel: " .. channel); else
      print ("Tickisms status: disabled - Version: " .. VERSION .. " - Default Channel: " .. channel);
    end
  elseif command == "CHANNEL" and rest == "" then
      print ("Default Channel is: " .. channel);
  elseif command == "QUOTE" and rest == "" then
    if status then
      if channel == "GUILD" or channel == "PARTY" or channel == "SAY" then
        SendChatMessage(Tickisms_Login_Array[math.random(table.getn(Tickisms_Login_Array))], channel);
        channel = oldchannel;
      end
    end
  else
   print ("usage: /tickisms on     - enables messages");
   print ("           /tickisms off      - disables messages");
   print ("           /tickisms status - prints current status and version");
   print ("           /tickisms quote [guild,party,say] - says random quote [default say]");
   print ("           /tickisms channel [guild,party,say] - Changes default channel");
   print ("           /tickisms help   - prints this message");
  end
end

-- ****************************************************************************************************** --
-- Function: Determines wheater a named item is present in bags
--
local function HaveItem(name)
-- check bags (doesn't check bank or keyring)
  for i = NUM_BAG_FRAMES, 0, -1 do
    for j = GetContainerNumSlots(i), 1, -1 do
      if (GetItemInfo(GetContainerItemLink(i, j) or "") == name) then 
        return true;
      end
    end
  end
  return false;
end
-- ****************************************************************************************************** --
-- Function: Event for TRADE_SKILL_SHOW - Put on Cheif Hat
--
function TickismsFrame.TRADE_SKILL_SHOW()
-- Something other then cooking open 
  if (GetTradeSkillLine() ~= "Cooking") then
    return;
  end
-- Somebody else trade skill linked
  if IsTradeSkillLinked() then
    return;
  end

-- 46349 is Cheif Hat, check and see if you have it
  if (HaveItem(GetItemInfo(46349))) then
-- Save old head info
    oldHeadLink = GetInventoryItemLink("player", GetInventorySlotInfo("HeadSlot"));
-- No Head item found, assume no head piece
    if (not oldHeadLink) then 
      oldHeadLink = ""; 
    end
-- Check and see if you already wearing chef hat
    if (GetItemInfo(oldHeadLink) == GetItemInfo(46349)) then
      oldHeadLink = nil;
    end
-- equip Chef's Hat
    ClearCursor(); -- ensure cursor is clear
    EquipItemByName(46349);
    ClearCursor(); -- ensure cursor is clear
-- show it off!
    oldShowHead = ShowingHelm();
    ShowHelm(true);

-- 5197 is Rolling Pin, check and see if you have it
    if (HaveItem(GetItemInfo(5197))) then
-- Save old Weapon info
      oldWeaponLink = GetInventoryItemLink("player", GetInventorySlotInfo("MainhandSlot"));
-- No Weapon item found, assume no Weapon
      if (not oldWeaponLink) then 
        oldWeaponLink = ""; 
      end
-- Check and see if you already wearing chef hat
      if (GetItemInfo(oldWeaponLink) == GetItemInfo(5197)) then
        oldWeaponLink = nil;
      end
-- equip Rolling Pin
      ClearCursor(); -- ensure cursor is clear
      EquipItemByName(5197);
      ClearCursor(); -- ensure cursor is clear
    end
  
-- show "Chef" title!
    if (IsTitleKnown(52)) then
      oldTitle = GetCurrentTitle();
      SetCurrentTitle(52);
    end
-- Say Quote
    local _, chefsHeadLink = GetItemInfo(46349)
--  print(chefsHeadLink .. " equipped! " .. Tickisms_cooking_Array[math.random(table.getn(Tickisms_cooking_Array))]);
    if status then
      SendChatMessage(chefsHeadLink .. " equipped! " .. Tickisms_cooking_Array[math.random(table.getn(Tickisms_cooking_Array))], channel);
    end
  else
-- no Chef's Hat (or already equipped)
    oldHeadLink = nil;
  end
end
-- ****************************************************************************************************** --
-- Function: Event for TRADE_SKILL_Close - Take off Cheif Hat
--
function TickismsFrame.TRADE_SKILL_CLOSE()
-- if need to swap back from Chef's Hat
  if (oldHeadLink) then
-- if have name of old hat, swap to it
    if (oldHeadLink ~= "") then
      ClearCursor(); -- ensure cursor is clear
      EquipItemByName(oldHeadLink);
      ClearCursor(); -- ensure cursor is clear
-- note: will fail silently if already equipped or not found. I didn't do it!
    else
-- if had no old hat equipped, take it off
-- first find empty bag slot
     local bag, slot = nil, nil;
     for i = 4, 0, -1 do
       for j = 1, GetContainerNumSlots(i) do
         if (not GetContainerItemLink(i, j)) then
           bag = i; slot = j; break;
         end
       end
     end
-- unequip
      if (bag and slot) then
        ClearCursor(); -- ensure cursor is clear
        PickupInventoryItem(GetInventorySlotInfo("HeadSlot"));
        PickupContainerItem(bag, slot);
        ClearCursor(); -- ensure cursor is clear
      end
-- note: if no empty bag slots, will fail silently
    end

-- if need to swap back from Rolling Pin
  if (oldWeaponLink) then
-- if have name of old Weapon, swap to it
    if (oldWeaponLink ~= "") then
      ClearCursor(); -- ensure cursor is clear
      EquipItemByName(oldWeaponLink);
      ClearCursor(); -- ensure cursor is clear
-- note: will fail silently if already equipped or not found. I didn't do it!
    else
-- if had no old Weapon equipped, take it off
-- first find empty bag slot
     local bag, slot = nil, nil;
     for i = 4, 0, -1 do
       for j = 1, GetContainerNumSlots(i) do
         if (not GetContainerItemLink(i, j)) then
           bag = i; slot = j; break;
         end
       end
     end
-- unequip
      if (bag and slot) then
        ClearCursor(); -- ensure cursor is clear
        PickupInventoryItem(GetInventorySlotInfo("MainSlot"));
        PickupContainerItem(bag, slot);
        ClearCursor(); -- ensure cursor is clear
      end
-- note: if no empty bag slots, will fail silently
    end
  end

-- also restore other old settings
  ShowHelm(oldShowHead);
  if (oldTitle) then SetCurrentTitle(oldTitle); end
    oldHeadLink = nil;
  end
end
-- ****************************************************************************************************** --
-- Function: say tickisms when entering combat (only say 30% of the time)
--
function TickismsFrame.PLAYER_REGEN_DISABLED()

  if math.random(100) >= 70 and status then
    SendChatMessage("Spoooooon",channel);
  end
end

-- ****************************************************************************************************** --
-- Function: say tickisms when killing another player (not tested yet)
--
function TickismsFrame.PLAYER_PVP_KILLS_CHANGED()
  if status then
    sendChatMessage("Villains, I say to you now, Knock off all that Evil!",channel);
  end
end

-- ****************************************************************************************************** --
-- Function: Determines if you summoned your companion pet or mount, if summoned then say a tickisms
--
function TickismsFrame.COMPANION_UPDATE()

--  This section for summon of companion pet  
  if petsummoned == 0 then
    for i=1,GetNumCompanions("CRITTER") do
      cID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("CRITTER",i);
      if issummoned == 1 then
        petsummoned = 1;
        if status then
          SendChatMessage("I'll call you Speak because that's what you do.",channel);
        end
	break;
      end
    end
  else
    for i=1,GetNumCompanions("CRITTER") do
      CID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("CRITTER",i);
      if issummoned == 1 then break; end
    end
    if issummoned == nil  then
      petsummoned = 0;
    end
  end

--  This section for summon of mount
  if mounted == 0 then
    for i=1,GetNumCompanions("MOUNT") do
      cID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("MOUNT",i);
      if issummoned == 1 then
        mounted = 1;
        if status then
          SendChatMessage(Tickisms_mount_Array[math.random(table.getn(Tickisms_mount_Array))], channel);
        end
	break;
      end
    end
  else
    for i=1,GetNumCompanions("MOUNT") do
      CID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("MOUNT",i);
      if issummoned == 1 then break; end
    end
    if issummoned == nil  then
      mounted = 0;
    end
  end 
end

-- ****************************************************************************************************** --
-- Function: Prints saying if you recieve falling damage
-- 
function TickismsFrame.COMBAT_LOG_EVENT_UNFILTERED(self, event, ...)

  local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...);
  local playerName = UnitName("player");

  if (destFlags == "Falling") and (sourceFlags2 == playerName) and (status) then
    SendChatMessage("Gravity is a harsh mistress.",channel);
  end
   
end

-- ****************************************************************************************************** --
-- Function: Sets everything for Player Entering World
--
function TickismsFrame.PLAYER_ENTERING_WORLD()
  print ("Tickisms: ", VERSION, " loaded");
  
  if status then
    SendChatMessage(Tickisms_Login_Array[math.random(table.getn(Tickisms_Login_Array))], channel);
  end

-- Determines if you have pet or mount out at start
  for i=1,GetNumCompanions("CRITTER") do
    cID, CName, CSpellID, icon, issummoned = 	GetCompanionInfo("CRITTER",i);
    if issummoned then 
      petsummoned = 1;
      break;
    end
  end

  if IsMounted() == 1 then
    mounted=1;
  end

-- Register events
  TickismsFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
  TickismsFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
  TickismsFrame:RegisterEvent("COMPANION_UPDATE");
  TickismsFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
  TickismsFrame:RegisterEvent("TRADE_SKILL_SHOW");
  TickismsFrame:RegisterEvent("TRADE_SKILL_CLOSE");

  TickismsFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
  TickismsFrame.PLAYER_ENTERING_WORLD = nil;

end
-- ****************************************************************************************************** --
